=== dolfin/ts/CMakeLists.txt ===
set(HEADERS
  dolfin_ts.h
  CVode.h
  PARENT_SCOPE)

set(SOURCES
  CVode.cpp
  PARENT_SCOPE)
