=== debian/changelog ===
dolfin (2018.1.0.post1-16) unstable; urgency=medium

  * use ctest --output-on-failure not -output-on-failure

 -- Drew Parsons <dparsons@debian.org>  Mon, 11 Feb 2019 19:14:25 +1100

dolfin (2018.1.0.post1-15) unstable; urgency=medium

  * symlink man-page for fenics-version to manpage for dolfin-version
  * run ctest with -output-on-failure to show details of test failures

 -- Drew Parsons <dparsons@debian.org>  Mon, 11 Feb 2019 13:58:33 +1100

dolfin (2018.1.0.post1-14) unstable; urgency=medium

  * add debian patch pytest_fixtures_096217a.patch
    (upstream commit 096217a0a3cb710e869d7e82a3d3609c4d968b76)
    to update tests for latest pytest API.
  * debhelper compatibility level 12
  * dolfin-bin installs /usr/bin/fenics-version
  * usr/share/dolfin/dolfin.conf is redundant on Debian,
    list it in debian/not-installed
  * debian/rules:
    - skip C++ build-time tests of demo_elastodynamics_mpi
      (unreliable, sometimes passes, but fails with pdebuild)
    - override dh_dwz to ignore python module .so files (already
      stripped by python's setuptools)

 -- Drew Parsons <dparsons@debian.org>  Sat, 09 Feb 2019 18:07:21 +1100

dolfin (2018.1.0.post1-13) unstable; urgency=medium

  * Standards-Version: 4.3.0
  * create patch PETSc_3.10_SNESTEST_removed.patch to work with
    PETSc 3.10 (SNESTEST has been removed). Thanks Jed Brown.

 -- Drew Parsons <dparsons@debian.org>  Wed, 26 Dec 2018 09:14:38 +0100

dolfin (2018.1.0.post1-12) unstable; urgency=medium

  * apply strict versioned depends on pybind11,
    python3-dolfin Depends: pybind11 (>= 2.2.4), pybind11 (<= 2.2.5)
    Closes: #909407.
  * Hardening: add dpkg-buildflags CXXFLAGS to CMAKE_CXX_FLAGS and
    python module build
  * use VERBOSE build of python modules

 -- Drew Parsons <dparsons@debian.org>  Mon, 24 Sep 2018 03:03:27 +0800

dolfin (2018.1.0.post1-11) unstable; urgency=medium

  * skip slow build-time tests (>500-1000 sec to complete)
  * rebuild for pybind11 2.2.4

 -- Drew Parsons <dparsons@debian.org>  Sun, 23 Sep 2018 04:58:48 +0800

dolfin (2018.1.0.post1-10) unstable; urgency=medium

  * skip build-time tests:
    - demo_auto-adaptive-poisson_serial test on m68k
    - demo_cahn-hilliard_mpi and other MPI tests on mips
    - all tests on sh4

 -- Drew Parsons <dparsons@debian.org>  Tue, 04 Sep 2018 03:53:23 +0800

dolfin (2018.1.0.post1-9) unstable; urgency=medium

  * autopkgtest: configure cpp tests with mpicc to ensure that the
    cmake test for PetscInt passes
  * Standards-Version: 4.2.1

 -- Drew Parsons <dparsons@debian.org>  Mon, 03 Sep 2018 04:17:35 +0800

dolfin (2018.1.0.post1-8) unstable; urgency=medium

  * mark libdolfin2018.1 as Multi-Arch: same
  * python3-dolfin Depends: python3-six
  * Standards-Version: 4.2.0

 -- Drew Parsons <dparsons@debian.org>  Fri, 17 Aug 2018 00:11:03 +0800

dolfin (2018.1.0.post1-7) unstable; urgency=medium

  * skip demo_stokes-taylor-hood_mpi test on mips64el

 -- Drew Parsons <dparsons@debian.org>  Wed, 01 Aug 2018 22:54:05 +0800

dolfin (2018.1.0.post1-6) unstable; urgency=medium

  * skip demo_cahn-hilliard_mpi, demo_ale_mpi, demo_poisson-disc_mpi
    tests on mipsel
  * skip demo_elasticity_serial test on m68k
  * run build-time tests on mips, but skip demo_cahn-hilliard_serial,
    demo_hyperelasticity_serial

 -- Drew Parsons <dparsons@debian.org>  Tue, 31 Jul 2018 15:16:58 +0800

dolfin (2018.1.0.post1-5) unstable; urgency=medium

  * update debian/test (autopkgtest) Depends
  * skip demo_sym-dirichlet-bc_mpi test on ppc64el
  * skip ALL build-time tests on mips, hurd-i386

 -- Drew Parsons <dparsons@debian.org>  Sat, 28 Jul 2018 22:42:00 +0800

dolfin (2018.1.0.post1-4) unstable; urgency=medium

  * skip demo_bcs_mpi test on mips64el
  * update debian/tests/control Depends: @, @builddeps@
    (to provide c++)

 -- Drew Parsons <dparsons@debian.org>  Fri, 27 Jul 2018 14:47:32 +0800

dolfin (2018.1.0.post1-3) unstable; urgency=medium

  * update skipped tests:
    - skip demo_navier-stokes_mpi test on arm64
    - skip demo_contact-vi-tao_mpi on mips64el
    - skip demo_stokes-iterative_mpi on mipsel
    - skip all MPI tests on armhf, i386, hppa, powerpc
  * don't download fresh source for tests
  * do copy symlink contents for C++ tests (in particular, copy
    pulley.xdmf for demo_elasticity)
  * tests Depends: python3-pytest

 -- Drew Parsons <dparsons@debian.org>  Fri, 27 Jul 2018 02:42:56 +0800

dolfin (2018.1.0.post1-2) unstable; urgency=medium

  * new upstream version for unstable.
    Some minor API changes:
      - Rename `mpi_comm_world()` to `MPI.comm_world`.
      - Rename `ERROR`, `CRITICAL` etc. to `LogLevel.ERROR`,
        `LogLevel.CRITICAL`.
  * skip demo_curl-curl_mpi test on mips64el

 -- Drew Parsons <dparsons@debian.org>  Thu, 26 Jul 2018 01:19:42 +0800

dolfin (2018.1.0.post1-1exp6) experimental; urgency=medium

  * skip all MPI tests on ppc64el

 -- Drew Parsons <dparsons@debian.org>  Wed, 11 Jul 2018 10:39:00 +0800

dolfin (2018.1.0.post1-1exp5) experimental; urgency=medium

  * updates to debian/rules:
    - identify build dir using DEB_HOST_GNU_TYPE
    - respect the parallel flag in DEB_BUILD_OPTIONS when running tests
    - skip cahn-hilliard, elasticity, elastodynamics MPI build tests
      which fail or time out for: armel mips64el ppc64el
    - skip m68k MPI tests altogether (times out)
  * debian patch unittests_demos_include_dirs.patch ensures include
    directories are defined for tests without reconfiguring cmake
  * link elasticity/pulley.xdmf from python demo to cpp demo
  * allow parallel jobs (max 8) in CI test test-dolfin-cpp

 -- Drew Parsons <dparsons@debian.org>  Sun, 08 Jul 2018 13:14:48 +0800

dolfin (2018.1.0.post1-1exp4) experimental; urgency=medium

  * Enable installation CI testing with Testsuite: autopkgtest.
  * run build-time tests including unittests and demos
    - use --oversubscribe with openmpi tests
    - skip demo_hyperelasticity_mpi (it diverges)

